#include "goboard.h"

string trim(string str)
{
	char const* delims = " \t\r\n";

	// trim leading whitespace
	string::size_type  notwhite = str.find_first_not_of(delims);
	str.erase(0,notwhite);

	// trim trailing whitespace
	notwhite = str.find_last_not_of(delims);
	str.erase(notwhite+1);
	return(str);
}


int goboard::readboard(char *file)
{
	string temp;
	unsigned int y;
	ifstream in (file, ios::in);
	
	if (!in)
		return(EXIT_FAILURE);

	sizeX=0;
	
	while (getline(in, temp))	// sizeY is size of string in the while
	{				// loop to reference **board array 
					// divide by 2. Ugly.
		temp = trim(temp);
		if (sizeX == 0)		// If this is first row added
		{
			sizeY = temp.size();
		} else if(temp.size() != sizeY) 
		{
			cout << "wtf?" << temp.size() << " " << sizeY << endl;
			return(EXIT_FAILURE);
		}

		for (y=0;y<=sizeY;y+=2)
		{	
			if (!((temp[y] == *"x") || (temp[y] == *".")))
			{ 
				cout << "Bad dot" << endl;
				return(EXIT_FAILURE); 
			}
			board[sizeX][y/2] = (temp[y]==*"x")?1:0;
		}
		sizeX++;
	} 
	
	sizeX--;	// Hacks!
	sizeY=(sizeY/2);

	if (sizeY == 0 && sizeX == 0)
	{
		cout << "No data read" << endl;
		return(EXIT_FAILURE);
	}
		
	return(EXIT_SUCCESS);
}

int goboard::printboard()
{
	unsigned int y, x;
	cout << "Board loaded: " << endl;
	cout << " ";
	for (y=0;y<=sizeY;y++)
		cout << char(y+65) << " ";
	cout << endl;
	for (x=0;x<=sizeX;x++)
	{
		cout << sizeX-x+1;
		for (y=0;y<=sizeY;y++)
		{
			if (board[x][y] == 0)
				cout << ". ";
			else
				cout << "x ";
		}
		cout << endl;
	}
	
	return(EXIT_SUCCESS);
}

int goboard::findgroups()
{
	unsigned int x, y;
	int group;
	for (x=0;x<=sizeX;x++)
	{
		for (y=0;y<=sizeY;y++)
		{
			if (board[x][y] == 1)
			{
				if ((group = ingroup(x, y)) != -1)
				{
					class Group ny;
					groups[group].addgroup(x, y);
				} else {
					class Group ny;
					ny.addgroup(x, y);
					groups.push_back(ny);
				}
			}
		}
	}

	return(EXIT_SUCCESS);
}

int goboard::printgroups()
{
	int sx = groups.size(), tmpx;
	cout << "Groups: " << endl;
	for (tmpx=0;tmpx<sx;tmpx++)
	{
		groups[tmpx].printgroup(sizeX);
	}

	return(EXIT_SUCCESS);
}

int goboard::ingroup(int x, int y)
{
	int sx = groups.size(), tmpx;

	if (sx == 0)
		return(-1);
	else 
		sx--;
	
	for (tmpx=0;tmpx<=sx;tmpx++)	// If in group return group
	{
		if((x-1)>=0)
			if(groups[tmpx].ingroup(x-1, y) == true)
				return(tmpx);
		if((x+1)<=(int)sizeX)
			if(groups[tmpx].ingroup(x+1, y) == true)
				return(tmpx);
		if((y-1)>=0)
			if(groups[tmpx].ingroup(x, y-1) == true)
				return(tmpx);
		if((y+1)<=(int)sizeY)
			if(groups[tmpx].ingroup(x, y+1) == true)
				return(tmpx);
	}

	return(-1);
}

