#include "goboard.h"

void help(string err);

int main(int argc, char **argv)
{
	class goboard board;
	string err;
	
	if (argc < 3 && argc > 1)
	{
		// Read board from file.
		if (board.readboard(argv[1]) != EXIT_SUCCESS)
			help(err = "board.readboard error.");

		if (board.printboard() != EXIT_SUCCESS)
			help(err = "board.printboard error.");

		// Find and print groups.
		if (board.findgroups() != EXIT_SUCCESS)
			help(err = "board.findgroups error.");
		if (board.printgroups() != EXIT_SUCCESS)
			help(err = "board.printgroups error.");

		// Clean up and exit.
		exit(EXIT_SUCCESS);
	} else {
		help(err = "");
		exit(EXIT_FAILURE);
	}
}

void help(string err)
{
	if (err.size() != 0)
		cout << "Error: " << err << endl;
	cout << "Usage: " << endl << "gogroups filename" << endl;
	if (err.size() != 0)
		exit(EXIT_FAILURE);
	return;
}
